<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/helpers/rich-config/build-core/src/generate_map.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>generate_map.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../rich_config_build_core/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../rich_config_build_core/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../rich_config_build_core/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">std::borrow::Borrow</span>;

<span class="kw">use</span> <span class="ident">proc_macro2::TokenStream</span>;
<span class="kw">use</span> <span class="ident">quote::quote</span>;

<span class="kw">use</span> <span class="ident">rich_config_types</span>::{<span class="ident">RichConfig</span>, <span class="ident">Value</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::BuildTimeRichConfig</span>;

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Borrow</span><span class="op">&lt;</span><span class="ident">RichConfig</span><span class="op">&gt;</span><span class="op">&gt;</span> <span class="ident">BuildTimeRichConfig</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">generate_map_fragment</span>(
        <span class="kw-2">&amp;</span><span class="self">self</span>,
        <span class="ident">fn_name_ident</span>: <span class="ident">TokenStream</span>,
        <span class="ident">helpers_module_path</span>: <span class="ident">TokenStream</span>,
    ) -&gt; <span class="ident">TokenStream</span> {
        <span class="kw">let</span> <span class="ident">value_path</span> <span class="op">=</span> <span class="macro">quote!</span> {
            #<span class="ident">helpers_module_path::Value</span>
        };
        <span class="kw">let</span> <span class="ident">to_string_path</span> <span class="op">=</span> <span class="macro">quote!</span> {
            #<span class="ident">helpers_module_path::ToString::to_string</span>
        };
        <span class="kw">let</span> <span class="ident">insertions</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">borrow</span>().<span class="ident">iter</span>().<span class="ident">map</span>(<span class="op">|</span>(<span class="ident">k</span>, <span class="ident">v</span>)<span class="op">|</span> {
            <span class="kw">let</span> <span class="ident">v</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">v</span> {
                <span class="ident">Value::Bool</span>(<span class="ident">v</span>) =&gt; {
                    <span class="macro">quote!</span> {
                        #<span class="ident">value_path::Bool</span>(#<span class="ident">v</span>)
                    }
                }
                <span class="ident">Value::String</span>(<span class="ident">v</span>) =&gt; {
                    <span class="macro">quote!</span> {
                        #<span class="ident">value_path::String</span>(#<span class="ident">to_string_path</span>(#<span class="ident">v</span>))
                    }
                }
                <span class="ident">Value::FilePath</span>(<span class="ident">v</span>) =&gt; {
                    <span class="macro">quote!</span> {
                        #<span class="ident">value_path::FilePath</span>(#<span class="ident">to_string_path</span>(#<span class="ident">v</span>))
                    }
                }
            };
            <span class="macro">quote!</span> {
                <span class="ident">config</span>.<span class="ident">insert</span>(
                    #<span class="ident">to_string_path</span>(#<span class="ident">k</span>),
                    #<span class="ident">v</span>,
                );
            }
        });
        <span class="macro">quote!</span> {
            <span class="kw">fn</span> #<span class="ident">fn_name_ident</span>() -&gt; #<span class="ident">helpers_module_path::RichConfig</span> {
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">config</span> <span class="op">=</span> #<span class="ident">helpers_module_path::RichConfig::empty</span>();
                #(#<span class="ident">insertions</span>)<span class="op">*</span>
                <span class="ident">config</span>
            }
        }
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="rich_config_build_core" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>